"use strict";const config=require("../config").global,fetch=require("node-fetch"),fronti_api_url=`${process.env.ADMIN_API_URL||"https://admin.codehooks.io"}`,graphql=async({query:a,variables:b},c)=>{const d={method:"post",body:JSON.stringify({query:a,variables:b}),headers:{"Content-Type":"application/json",Authorization:`Bearer ${config.get("token")}`,...c},redirect:"follow"};try{const a=await fetch(`${fronti_api_url}/graphql`,d);return a.json()}catch(a){const b=new Error(`Unable to retrieve data from the codehooks API`);throw b}};exports.pingServer=async(a,b={})=>graphql({query:`
  query {
    ping
  }
  `,variables:a},b),exports.currentUser=async(a,b={})=>graphql({query:`
  {
    currentUser {
        id
        name
        email
        sub
        termsAccepted
        ProjectInvitations {
          id
          projectId
          projectName
          role
          createdByEmail
          createdByName
          createdDate
        }
        TeamInvitations {
          id
          teamId
          teamName
          role
          createdDate
          createdByName
          createdByEmail
        }
        UserProjects {
            id 
            uniqueName
            Team {
                id name isDefaultTeam
            }
            Members {
              user {
                id
                email
                name
              }
              role
            }
            Datastores {
                id
                name
                projectId
                restricted
                Tokens {
                  key
                  access
                  description
                }
                allowedHosts
                jwks
                Env {
                  key
                  value
                  encrypted
                }
                Domains {
                  name
                  description
                }
                DefaultDomain {
                  name
                  description
                }
            }
        }
        Projects {
          id 
          uniqueName
          Team {
              id name isDefaultTeam
          }
          Members {
            user {
              id
              email
              name
            }
            role
          }
          Datastores {
              id
              name
              projectId
              restricted
              Tokens {
                key
                access
                description
              }
              allowedHosts
              jwks
              Env {
                key
                value
                encrypted
              }
              Domains {
                name
                description
              }
              DefaultDomain {
                name
                description
              }
          }
        }
        UserTeam {
            id
            name
            AdminTokens {
              id
              secret
            }
        }
        Teams {
            id 
            name
            AdminTokens {
              id
              secret
            }
            Members {
              user {id}
              role
            }
            Projects {
              id
              uniqueName
            }
        }
    }
}
  `,variables:a},b),exports.addProject=async(a,b={})=>graphql({query:`
    mutation
      addProject(
        $name: String!
        $description: String
        $teamId: ID){ 
        addProject(
          name: $name
          description: $description
          teamId: $teamId) {
            id
            uniqueName
            name
            Team {
              id
              name
              isDefaultTeam
            }
        }
      }
  `,variables:a},b),exports.addDatastore=async(a,b={})=>graphql({query:`
  mutation addDatastore($projectId: ID! $name: String!) {
    addDatastore(
      projectId: $projectId
      name: $name) {
        id
        name
        projectId
        Tokens {
          key
          access
          description
        }
      }
  }
  `,variables:a},b),exports.removeDatastore=async(a,b={})=>graphql({query:`
  mutation removeDatastore($datastoreId: ID!) {
    removeDatastore(
      datastoreId: $datastoreId
      ) {
        id
      }
  }
  `,variables:a},b),exports.addToken=async(a,b={})=>graphql({query:`
  mutation addToken($datastoreId: ID! $access: TokenAccess! $description: String) {
    addToken(
      datastoreId: $datastoreId
      access: $access
      description: $description) {
        key
        datastoreId
        access
        description
      }
  }
  `,variables:a},b),exports.removeToken=async(a,b={})=>graphql({query:`
  mutation removeToken($datastoreId: ID! $tokenId: ID!) {
    removeToken(
      datastoreId: $datastoreId
      tokenId: $tokenId) {
        key
      }
  }
  `,variables:a},b),exports.addAllowedHost=async(a,b={})=>graphql({query:`
  mutation addAllowedHost($datastoreId: ID! $ip: IPv4!) {
    addAllowedHost(
      datastoreId: $datastoreId
      ip: $ip)
  }
  `,variables:a},b),exports.removeAllowedHost=async(a,b={})=>graphql({query:`
  mutation removeAllowedHost($datastoreId: ID! $ip: IPv4!) {
    removeAllowedHost(
      datastoreId: $datastoreId
      ip: $ip)
  }
  `,variables:a},b),exports.setJWKS=async(a,b={})=>graphql({query:`
  mutation setJWKS ($datastoreId:ID! $jwksURI: URL!) {
    setJWKS(
      datastoreId:$datastoreId
      jwksURI: $jwksURI
    )
  }
  `,variables:a},b),exports.setEnv=async(a,b={})=>graphql({query:`
  mutation setEnv($datastoreId: ID! $key: String! $value: String! $encrypted: Boolean) {
    setEnv(
      datastoreId: $datastoreId
      key: $key
      value: $value
      encrypted: $encrypted
      ) {
        key
        value
        encrypted
      }
  }
  `,variables:a},b),exports.removeEnv=async(a,b={})=>graphql({query:`
  mutation removeEnv ($datastoreId:ID! $key: String!) {
    removeEnv(
      datastoreId: $datastoreId
      key: $key
    ){
      key
      value
    }
  }
  `,variables:a},b),exports.projectInvitations=async(a,b={})=>graphql({query:`
  {
    currentUser {
      id
      name
      email
      sub
      ProjectInvitations {
        id
        projectId
        projectName
        role
        createdByEmail
        createdByName
        createdDate
      }
      UserProjects {
          id 
          uniqueName
          Team {
              id name isDefaultTeam
          }
          Invitations {
            id
            email
            role
            createdByEmail
            createdByName
            createdDate
          }
      }
      Projects {
        id 
        uniqueName
        Team {
            id name isDefaultTeam
        }
        Invitations {
          id
          email
          role
          createdByEmail
          createdByName
          createdDate
        }
      }
      Teams {
        id 
        name
        Members {
          user {id}
          role
        }
        Projects {
          id
          uniqueName
        }
    }
  }
}
  `,variables:a},b),exports.addProjectInvitation=async(a,b={})=>graphql({query:`
  mutation addProjectInvitation($projectId: ID! $email: EmailAddress! $role: ProjectRole!) {
    addProjectInvitation(projectId: $projectId, email: $email, role: $role) {
      id
      projectId
      email
    }
  }
  `,variables:a},b),exports.joinProject=async(a,b={})=>graphql({query:`
  mutation joinProject($projectId: ID!) {
    joinProject(projectId: $projectId)
  }
  `,variables:a},b),exports.leaveProject=async(a,b={})=>graphql({query:`
  mutation removeProjectMember($projectId: ID! $userId: ID) {
    removeProjectMember(
      projectId: $projectId
      userId: $userId
      )
  }
  `,variables:a},b),exports.acceptProjectInvitation=async(a,b={})=>graphql({query:`
  mutation acceptProjectInvitation($invitationId: ID!) {
    acceptProjectInvitation(
      invitationId: $invitationId
      )
  }
  `,variables:a},b),exports.removeProjectInvitation=async(a,b={})=>graphql({query:`
  mutation removeProjectInvitation($invitationId: ID!) {
    removeProjectInvitation(
      invitationId: $invitationId)
  }
  `,variables:a},b),exports.getSpace=async(a,b)=>{const c=await exports.currentUser(),d=[...c.data.currentUser.UserProjects,...c.data.currentUser.Projects].find(b=>b.uniqueName===a);if(!d)throw"Project not found";const e=d.Datastores.find(a=>a.name===b);if(!e)throw"Space not found";return e},exports.acceptTeamInvitation=async(a,b={})=>graphql({query:`
  mutation acceptTeamInvitation($invitationId: ID!) {
    acceptTeamInvitation(
      invitationId: $invitationId
      )
  }
  `,variables:a},b),exports.removeTeamInvitation=async(a,b={})=>graphql({query:`
  mutation removeTeamInvitation($invitationId: ID!) {
    removeTeamInvitation(
      invitationId: $invitationId)
  }
  `,variables:a},b),exports.acceptTerms=async(a,b={})=>graphql({query:`
  mutation acceptTerms {
    acceptTerms 
  }
  `,variables:a},b),exports.addAdminToken=async(a,b={})=>graphql({query:`
  mutation addAdminToken($teamId: ID!) {
    addAdminToken(
      teamId: $teamId
    ) {
      id
      secret
    }
  }
  `,variables:a},b),exports.removeAdminToken=async(a,b={})=>graphql({query:`
  mutation removeAdminToken($teamId: ID! $tokenId: ID!) {
    removeAdminToken(
      teamId: $teamId
      tokenId: $tokenId
    )
  }
  `,variables:a},b);