"use strict";const{writeFileSync,existsSync}=require("fs"),inquirer=require("inquirer"),lodash=require("lodash"),fetch=require("node-fetch"),config=require("../config").global,async=require("async"),mkdirp=require("mkdirp"),path=require("path"),createProjectConfig=require("../config").createProjectConfig,projectConfig=require("../config").project,{currentUser,addProject,addDatastore,addToken}=require("../api"),sortFunc=require("../lib/sortFunc"),cwd=process.cwd();exports.command="init [projectname] [space]",exports.desc="Initialise an existing project space in the current folder. Sets up default CRUD template in index.js.";const builderOptions={projectname:{alias:"n",description:"Project name"},space:{alias:"s",description:"Space (environment) name",default:"dev"},empty:{alias:"e",description:"Only create the project config file",type:"boolean"},download:{description:"Download source code from project",type:"boolean",default:!0}};exports.builder=a=>{lodash.each(builderOptions,(b,c)=>{a.option(c,b)}),a.example("$0 init"),a.example("$0 init --empty"),a.example("$0 init --download")},exports.handler=async function(a){try{const b=await currentUser(),c=b.data.currentUser,d=[...c.UserProjects,...c.Projects].sort(sortFunc("uniqueName"));a.debug&&console.error("User",c);try{const a=projectConfig&&projectConfig.get("name");if(a)throw Error("Existing config.json found.");else if(existsSync(`${cwd}/${"development"===process.env.NODE_ENV?"config-dev":"config"}.json`))throw Error(`Invalid or existing config.js found. Unable to restore project in this folder.`)}catch(a){throw Error(a.message||"Unable to read existing config.json")}if(!a.empty&&existsSync(`${cwd}/index.js`))throw Error(`index.js found! Unable to restore project in this folder.`);const e={type:"list",name:"project",choices:d.map(a=>a.uniqueName),message:"Select project"};let f,g=a.projectname||"";!a.projectname&&0<d.length&&(f=await inquirer.prompt([e]),g=f&&f.project);const h=d.find(a=>a.uniqueName===g);if(!h)throw Error(`Project '${g}' not found`);let i=a.space||"";if(f&&0<h.Datastores.length){const a={type:"list",name:"space",choices:h.Datastores.map(a=>a.name),message:"Select space"},b=await inquirer.prompt([a]);i=b.space}const j=h.Datastores.find(a=>a.name===i);if(!j)throw Error(`Space '${i}' not found!`);const k=`
/*
* Auto generated Codehooks (c) example
* Install: npm i codehooks-js
*/
import {app} from 'codehooks-js'

// test route for https://${g}.api.codehooks.io/${i}/
app.get('/', (req, res) => {
  res.send('CRUD server ready')
})

// Use Crudlify to create a REST API for any collection
app.crudlify()

// bind to serverless runtime
export default app.init();
`,l=`
{
  "name": "${h.uniqueName}",
  "version": "1.0.0",
  "description": "Codehooks backend app",
  "main": "index.js",
  "scripts": {
    "deploy": "codehooks deploy && codehooks logs --follow"
  },
  "author": "${c.email}",
  "license": "ISC",
  "dependencies": {
    "codehooks-js": "latest"
  }
}
`;try{const b=createProjectConfig(cwd);b.set("name",g),b.set("space",i),a.empty?console.log("Created config.json for project link, happy coding"):a.download&&downloadSourceCode(a,g,i,(a,b)=>{a&&console.error(a),"No deployed source code found"===b?(writeFileSync(`${cwd}/index.js`,k),writeFileSync(`${cwd}/package.json`,l),console.log("Successfully restored project with code template!\n")):"All files have been downloaded"==b&&console.log("Successfully restored project with deployed code!\n"),console.log("Run: npm install && npm run deploy\n")}),console.log("Install packages: npm i codehooks-js"),console.log("Deploy: coho deploy"),console.log("API tokens: coho info")}catch(b){throw a.debug&&console.error(b),Error("Unable to create config.json and index.js")}}catch(b){console.log(b&&b.message||"Unable to initalise project"),a.debug&&console.error(b)}};async function downloadSourceCode(a,b,c,d){if(!a.download)return d(null,"done");const{admintoken:e,_auth:f={}}=a,g=!e?config.get("token"):null;var h={"Content-Type":"application/octet-stream",host:`${b}.meta.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`,"x-space":c};({admintoken:e,myAPIKey:g}).admintoken?h["x-admintoken"]=e:h.Authorization=`Bearer ${g}`;var i={method:"GET",headers:h,redirect:"follow",rejectUnauthorized:!1};const j=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${c}/tree`:`https://${b}.meta.codehooks.io/${c}/tree`;a.debug&&console.log(j,i);const k=await fetch(j,i);k.ok||console.log(k.ok,k.status,k.statusText);const l=await k.json();if(!l)return d(null,"No deployed source code found");let m=[];m=flattenDirectory(l.children),a.debug&&console.log("Files",m.length);var n=async.queue(async function(d,e){const{type:f,path:g,name:i}=d.filePath,j=path.join(process.cwd(),g);if("directory"==f){//const filepath = `${process.cwd()}/${aPath}`;
await mkdirp(j);//console.log('mkdir', made, `${process.cwd()}/${aPath}`)
return e()}// else download a source file     
//console.log('Download', filepath)
const k={method:"GET",headers:h,redirect:"follow",rejectUnauthorized:!1},l=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${c}/src/${g}`:`https://${b}.meta.codehooks.io/${c}/src/${g}`;a.debug&&console.log(l,k);const m=await fetch(l,k);if(!m.ok)return console.error(m.status,m.statusText),e();const n=await m.text();console.log("Copy source file",j,n.length,"bytes"),writeFileSync(j,n),e()},1);// assign a callback
n.drain(function(){d(null,"All files have been downloaded")}),m.forEach(a=>{n.push({filePath:a})})}function flattenDirectory(a,b=""){let c=[];return a.forEach(a=>{const d=b+a.name;"file"===a.type?c.push({...a,path:d}):"directory"===a.type&&a.children&&(c.push({type:"directory",path:d}),c=c.concat(flattenDirectory(a.children,d+"/")))}),c}