"use strict";

var fs = require('fs');
module.exports.checkLanguage = function (cb) {
  var isTypescript = fs.existsSync('./index.ts');
  var isJavascript = fs.existsSync('./index.js');
  var hasTsConfig = fs.existsSync('./tsconfig.json');
  var tsconf = {
    "files": ["./index.ts"],
    "compilerOptions": {
      "lib": ["es2015", "dom"]
    }
  };
  if (isTypescript) {
    // create tsconfig.json
    if (!hasTsConfig) {
      fs.writeFile('tsconfig.json', JSON.stringify(tsconf), 'utf8', function (err) {
        cb(err, 'Typescript');
      });
    } else {
      cb(null, 'Typescript');
    }
  } else if (isJavascript) {
    cb(null, 'Javascript');
  } else {
    cb("Error: missing index.js");
  }
};