"use strict";

module.exports = function (source) {
  if (source.includes('require(')) {
    console.error('\nFile with offending require:', this.resourcePath, '\n👇');
    console.error('\n--- snippet ---\n', source.substr(source.indexOf('require('), 100), '...\n--- end snippet ---\n');
    throw new Error('Detected use of Node.js "require". Please use ESM import/export instead.');
  }
  if (source.includes('tty')) {
    console.error('\nFile with offending tty:', this.resourcePath, '\n👇');
    console.error('\n--- snippet ---\n', source.substr(source.indexOf('tty'), 100), '...\n--- end snippet ---\n');
    throw new Error('Detected use of Node.js "require". Please use ESM import/export instead.');
  }
  return source;
};