"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var Table = require('cli-table3');
var _ = require('lodash');
module.exports.showTableFormat = function (json) {
  // print schema
  var schema = {};
  _.each(json, function (datarow) {
    _.each(datarow, function (row, key) {
      //console.log(key);
      schema[key] = _typeof(row);
    });
  });
  var xtable = new Table({
    head: ['', 'Field', 'Type']
  });
  //xtable.concat(schema);
  var count = 0;
  _.each(schema, function (field, key) {
    if (key[0] !== '_' || key === '_id') {
      xtable.push([count++, key, field]);
    }
  });
  var colw = new Array(count);
  var i;
  var width = process.stdout.columns / count;
  for (i = 0; i < count; i++) {
    colw[i] = Math.floor(width) - 2;
  }
  //console.log("Schema")

  //console.log(xtable.toString());

  // instantiate auto col widths
  var ytable = new Table({
    head: _.map(xtable, function (x, k) {
      return x[1];
    }),
    colWidths: colw
  });
  _.each(json, function (row, key) {
    var data = [];
    _.each(schema, function (prop, key) {
      if (key[0] !== '_' || key === '_id') {
        var val = row[key];
        //console.log("val", prop, key, val, typeof val)
        data.push(val && val.toString ? _typeof(val) === 'object' ? JSON.stringify(val) : val.toString() : val);
      }
    });
    ytable.push(data);
  });
  console.log(ytable.toString());
};