"use strict";const{writeFileSync,existsSync}=require("fs"),unusedFilename=require("unused-filename"),inquirer=require("inquirer"),mkdirp=require("mkdirp"),createProjectConfig=require("../config").createProjectConfig,projectConfig=require("../config").project,config=require("../config").global,fetch=require("node-fetch"),{currentUser,addProject,addDatastore,addToken}=require("../api"),sortFunc=require("../lib/sortFunc"),cwd=process.cwd(),path=cwd.split("/"),pname=path[path.length-1];exports.command="create [projectname] [teamid] [description]",exports.desc="Create and initialize a new codehooks project",exports.aliases="init",exports.builder={description:{description:"A few words about this project"},projectname:{alias:"n",description:"Project name"},teamid:{alias:"t",description:"Add project to team with this id"},"ga-deploy":{alias:"g",description:"Add Github Action for automatic deploy",type:"boolean"}},exports.handler=async function(a){const b={name:a.projectname||pname,description:a.description,teamId:a.teamid},c=!a.projectname;if(a.projectname&&!/^[a-z0-9]{4,15}$/ig.test())return void console.log("Project name must contain a-z only, at least 4 at most 15 chars");if(c){const a=projectConfig.get("name");if(a)return void console.error("Project already initialized. Remove config.json to create a new.")}try{const d=await currentUser(),e=d.data.currentUser,f=e.Teams.map(a=>({name:a.name,value:a.id})).sort(sortFunc("name"));if(f.unshift({name:"Personal",value:"personal"}),b.teamId){const a=e.Teams.find(a=>a.id===b.teamId);if(!a)return void console.log("Team not found")}const g=c?`Add project '${pname}' in current folder`:"Project: ",h={type:c?"confirm":"input",name:"projectName",message:g,default:b.name,validate:a=>!!/^[a-z0-9]{4,15}$/ig.test(a.toLowerCase())||"Project name must contain a-z only, at least 4 at most 15 chars"},i=[h];b.teamId||i.push({type:"list",name:"team",when:a=>a.projectName,choices:f,message:"Select personal account or team to add project to"});const j=await inquirer.prompt(i);if(!1===j.projectName)return;if(!0===j.projectName&&(j.projectName=pname),!c&&existsSync(`${cwd}/${j.projectName.toLowerCase()}`))return void console.log(`Directory '${j.projectName.toLowerCase()}' exists!`);b.name=j.projectName,j.team&&"personal"!==j.team&&(b.teamId=j.team);const k=c?cwd:`${cwd}/${b.name}`,l=await addProject(b);if(l.errors)console.log(l.errors[0]&&l.errors[0].message||"Unable to initialize new project"),a.debug&&l.errors.forEach(a=>console.log(a&&a.message)),l.errors.some(a=>a.message&&-1!==a.message.indexOf("session"))&&console.log(`Please log in/sign up with: ${a.$0} login <provider>`);else{const b=l.data.addProject,d=createProjectConfig(k);d.set("name",l.data.addProject.uniqueName);const f=b.Team.isDefaultTeam?"your account":`'team ${b.Team.name}'`;console.log(`Successfully created a new project '${b.uniqueName}' in ${f}`);const g=await addDatastore({projectId:b.id,name:"dev"}),h=await addToken({datastoreId:g.data.addDatastore.id,access:"READWRITE"});d.set("space",g.data.addDatastore.name),console.log("Added new space 'dev' and set it to active");try{const a=`
{
  "name": "${b.uniqueName}",
  "version": "1.0.0",
  "description": "Codehooks backend app",
  "main": "index.js",
  "scripts": {
    "deploy": "codehooks deploy && codehooks logs --follow"
  },
  "author": "${e.email}",
  "license": "ISC",
  "dependencies": {
    "codehooks-js": "latest"
  }
}
`;c||(await mkdirp(k));const d=await unusedFilename(`${k}/index.js`);writeFileSync(d,"\n/*\n* Auto generated Codehooks (c) example\n* Install: npm i codehooks-js\n*/\nimport {app} from 'codehooks-js'\n\n// test route for https://<PROJECTID>.api.codehooks.io/dev/\napp.get('/', (req, res) => {\n  res.send('CRUD server ready')\n})\n\n// Use Crudlify to create a REST API for any collection\napp.crudlify()\n\n// bind to serverless runtime\nexport default app.init();\n");const f=await unusedFilename(`${k}/package.json`);writeFileSync(f,a),console.log("Created example file: "+d)}catch(b){console.log("Unable to generate example index.js and config file"),a.debug&&console.error(b)}try{if(a["ga-deploy"]){console.log("Creating Github Action folder and file .github/workflows/deploy-codehooks.yml");const a=`${k}/.github/workflows`;await mkdirp(a),writeFileSync(`${a}/deploy-codehooks.yml`,"\nname: CODEHOOKS DEPLOY\non:\n  push:\n    branches:\n      - main\n      - master\n  workflow_dispatch:\n\njobs:\n  deploy:\n    name: Install and deploy\n    runs-on: ubuntu-latest\n    steps:\n      - name: Checkout\n        uses: actions/checkout@v2\n        with:\n          persist-credentials: false\n\n      - name: Setup Node.js\n        uses: actions/setup-node@v1\n        with:\n          node-version: 16.x\n\n      - name: Deploy to codehooks\n        run: npx codehooks deploy --admintoken ${{ secrets.CODEHOOKS_ADMINTOKEN }}\n"),console.log("Please add CODEHOOKS_ADMINTOKEN as a github secret and set it to a codehooks admin token"),console.log("You create an admin token with 'coho add-admintoken'")}// deploy default code template
setTimeout(()=>{deployDefaultCode(a,b)},1e3)}catch(b){console.error("Unable to generate Github Action for automatic deploy"),a.debug&&console.error(b)}}}catch(b){console.error("Unable to initialize project"),a.debug&&console.error(b)}};function deployDefaultCode(a,b){const{admintoken:c,_auth:d={}}=a,e=!c?config.get("token"):null,f=d.name||"",g=d.email||"",h={"x-file-name":"bundle.js","Content-Type":"application/json",//"Content-length": bundle.length,
"x-githash":null,"x-gitbranch":null,"x-userfullname":f,"x-useremail":g,"x-date":new Date().toISOString(),"x-language":"Javascript",host:`${b.uniqueName}.api.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`};({admintoken:c,myAPIKey:e}).admintoken?h["x-admintoken"]=c:h.Authorization=`Bearer ${e}`;const i={method:"POST",headers:h,body:JSON.stringify({templateBundleId:"CRUDLIFY_TEMPLATE"}),json:!0,redirect:"follow"},j=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/dev/_A_D_M_deploy`:`https://${b.uniqueName}.api.codehooks.io/dev/_A_D_M_deploy`;a.debug&&console.log(j,i),fetch(j,i).then(async function(b){if(a.debug&&console.error(b.status+" "+b.statusText),400<=b.status){if(console.error(`Unable to perform deploy. ${b.status} ${b.statusText}`),a.debug){const a=await b.text();console.error(a)}process.exit(1)}return b.json()}).then(function(a){a.error&&console.error(a.error)}).catch(b=>{a.debug?console.error(b):console.error(b.message)})}