"use strict";const fetch=require("node-fetch"),fs=require("fs"),config=require("../config").global,projectConfig=require("../config").project,chalk=require("chalk"),ora=require("ora"),traverse=require("traverse"),dirTree=require("directory-tree"),async=require("async"),path=require("path"),JSONStream=require("JSONStream");let spinner=null;function msg(a){setTimeout(()=>{null===spinner?spinner=ora(a).start():spinner.text=a},1)}exports.command="file-delete [filename]",exports.aliases=["delete"],exports.desc="Delete a file from server",exports.builder=a=>{a.option("filename",{alias:"f",describe:"Delete file with match on absolute path/filename"}).option("match",{alias:"r",describe:"Delete multiple file that matches regular expression to a file path"}).option("space",{default:projectConfig.get("space"),describe:"Select which space (environment) to access"}).option("projectname",{default:projectConfig.get("name"),alias:"p",describe:"Select which project name to use"}).option("admintoken",{describe:"Use admin token authentication (use for CI)"}).option("dryrun",{type:"boolean",describe:"Output files to upload without performing the action"}).example("$0 delete --filename '/static/myfile.txt'").example("$0 delete --match '/static/*'").example("$0 delete --match '^/static/assets/.*\\.css$'")},exports.handler=async function(a){a.filename?deleteFile(a,a.filename,()=>{process.exit(0)}):a.match&&deleteManyFiles(a,(a,b)=>{console.log("The end",a,b)})};async function deleteFile(a,b,c){const{admintoken:d,_auth:e={}}=a,f=!d?config.get("token"):null;var g={"Content-Type":"application/octet-stream",host:`${a.projectname}.meta.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`,"x-space":a.space};({admintoken:d,myAPIKey:f}).admintoken?g["x-admintoken"]=d:g.Authorization=`Bearer ${f}`;const h={method:"DELETE",headers:g,redirect:"follow",rejectUnauthorized:!1};if(a.dryrun)return console.log("Delete file (dry run): "+b),c();console.log("Deleting: "+b);const i=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${a.space}/blob/${encodeURIComponent(b)}`:`https://${a.projectname}.meta.codehooks.io/${a.space}/blob/${encodeURIComponent(b)}`;a.debug&&console.log(i,h);try{const b=await fetch(i,h);b.ok||console.log(b.status,b.statusText);const d=await b.text();a.debug?console.log(d):0,c()}catch(a){console.error(a),c(a)}}async function deleteManyFiles(a,b){const c=!a.admintoken?config.get("token"):null;let d={path:{$regex:a.match}},e={};a.count&&(e.count=!0);const f=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${a.space}/_A_D_M_query/${"_blobs"}?q=${JSON.stringify(d)}&h=${JSON.stringify(e)}`:`https://${a.projectname}.api.codehooks.io/${a.space}/_A_D_M_query/${"_blobs"}?q=${JSON.stringify(d)}&h=${JSON.stringify(e)}`,g={"cache-control":"no-cache","content-type":"application/json",host:`${a.projectname}.api.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`};a.admintoken?g["x-admintoken"]=a.admintoken:g.Authorization=`Bearer ${c}`;const h={method:"GET",headers:g,json:!0};a.debug&&(console.log("Query called",a),console.log(d,e),console.log(f,h));// queue to upload one file at a time
const i=async.queue(async function(b,c){deleteFile(a,b.filePath,()=>{c&&c()})});try{const a=await fetch(f,h);if(400<=a.status){console.error(`Unable to execute command. ${a.status} ${a.statusText}`);const c=await a.text();console.error(chalk.red(c)),b(c)}else{let b=a.body.pipe(JSONStream.parse("*"));b.on("error",function(a){return console.error("JSON error ",a),b.end()}),b.on("data",function(a){i.push({filePath:a.path},function(){// done one file
})}),b.on("end",()=>{// nothing          
})}}catch(a){console.error("An error occured. Unable to process command.",a),process.exit(0)}}