"use strict";const fetch=require("node-fetch"),fs=require("fs"),config=require("../config").global,projectConfig=require("../config").project,chalk=require("chalk"),ora=require("ora"),traverse=require("traverse"),dirTree=require("directory-tree"),async=require("async"),path=require("path"),{Transform,pipeline}=require("node:stream"),{promisify}=require("node:util"),streamPipeline=promisify(pipeline),streamHandler=require("../lib/streamHandler"),JSONStream=require("JSONStream"),util=require("util"),_=require("lodash"),Table=require("cli-table3");let spinner=null;function msg(a){setTimeout(()=>{null===spinner?spinner=ora(a).start():spinner.text=a},1)}exports.command="file-list [path]",exports.aliases=["files"],exports.desc="List files from server",exports.builder=a=>{a.option("path",{default:".",alias:"f",describe:"Path to directory or file"}).option("space",{default:projectConfig.get("space"),describe:"Select which space (environment) to access"}).option("project",{default:projectConfig.get("name"),alias:"p",describe:"Select which project name to use"}).option("admintoken",{describe:"Use admin token authentication (use for CI)"}).options("reverse",{describe:"Scan index in reverse order"}).options("table",{type:"boolean",desc:"Output data as formatted table (not JSON)"}).options("json",{type:"boolean",desc:"Output data as formatted JSON"}).example("$0 list-file '/static/'")},exports.handler=async function(a){listFiles(a,()=>{//process.exit(0)
})};async function listFiles(a){const b=!a.admintoken?config.get("token"):null;let c={path:{$regex:a.path}},d={};a.count&&(d.count=!0);const e=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${a.space}/_A_D_M_query/${"_blobs"}?q=${JSON.stringify(c)}&h=${JSON.stringify(d)}`:`https://${a.project}.api.codehooks.io/${a.space}/_A_D_M_query/${"_blobs"}?q=${JSON.stringify(c)}&h=${JSON.stringify(d)}`,f={"cache-control":"no-cache","content-type":"application/json",host:`${a.project}.api.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`};a.admintoken?f["x-admintoken"]=a.admintoken:f.Authorization=`Bearer ${b}`;const g={method:"GET",headers:f,json:!0};a.debug&&(console.log("Query called",a),console.log(c,d),console.log(e,g)),1<[a.table,a.pretty,a.csv].filter(a=>!0===a).length&&(console.error("Please choose either --pretty, --table or --csv (or none)"),process.exit(1));try{const b=await fetch(e,g);if(400<=b.status){console.error(`Unable to execute command. ${b.status} ${b.statusText}`);const a=await b.text();console.error(chalk.red(a)),process.exit(1)}else if(a.table){const a=await b.json();showTableFormat(a),process.exit()}else if(a.json)await streamHandler(b.body.pipe(JSONStream.parse("*")),{onData:a=>console.log(util.inspect(a,{showHidden:!1,depth:null,colors:!0}))}),process.exit();else if(a.csv){const a=format({headers:!0});a.pipe(process.stdout),await streamHandler(b.body.pipe(JSONStream.parse("*")),{onData:b=>a.write(b)}),a.end(),process.exit()}else{//await streamPipeline(res.body, process.stdout);
//process.exit();
let a=b.body.pipe(JSONStream.parse("*"));a.on("error",function(b){//stream.input.unpipe()
return console.error("JSON error ",b),a.end()}),a.on("data",function(a){console.log(a.path)}),a.on("end",()=>{process.exit()})}}catch(b){console.error("An error occured. Unable to process query."),a.debug&&console.log(b),process.exit(1)}}const showTableFormat=a=>{// print schema
var b={};_.each(a,a=>{_.each(a,(a,c)=>{//console.log(key);
b[c]=typeof a})});var c=new Table({head:["","Field","Type"]}),d=0;//xtable.concat(schema);
_.each(b,(a,b)=>{("_"!==b[0]||"_id"===b)&&c.push([d++,b,a])});var e,f=Array(d),g=process.stdout.columns/d;for(e=0;e<d;e++)f[e]=Math.floor(g)-2;//console.log("Schema")
//console.log(xtable.toString());
// instantiate auto col widths
var h=new Table({head:_.map(c,a=>a[1]),colWidths:f});_.each(a,a=>{var c=[];_.each(b,(b,d)=>{if("_"!==d[0]||"_id"===d){var e=a[d];//console.log("val", prop, key, val, typeof val)
c.push(e&&e.toString?"object"==typeof e?JSON.stringify(e):e.toString():e)}}),h.push(c)}),console.log(h.toString())};