"use strict";const tar=require("tar"),fetch=require("node-fetch"),fs=require("fs"),config=require("../config").global,projectConfig=require("../config").project,tmp=require("tmp"),chalk=require("chalk"),lodash=require("lodash"),tables=require("../lib/tables"),checkLanguage=require("../lib/langhelp").checkLanguage,ora=require("ora"),compile=require("../lib/compile"),traverse=require("traverse"),dirTree=require("directory-tree"),async=require("async"),path=require("path");let spinner=null;function msg(a){setTimeout(()=>{null===spinner?spinner=ora(a).start():spinner.text=a},1)}exports.command="deploy",exports.aliases=["de","dep"],exports.desc="Deploys current codehook folder",exports.builder={dir:{default:"."},space:{default:projectConfig.get("space"),describe:"Select which space to access",alias:"s"},projectname:{default:projectConfig.get("name"),alias:"p",describe:"Select which project name to use"},history:{describe:"Show deployment history"},rollback:{describe:"Undo last deployment, set previous as active"},json:{describe:"Output JSON format"},admintoken:{describe:"Use admin token authentication (use for CI)"},template:{describe:"Deploy a pre defined code template"},upload:{describe:"Upload source code assets to codehooks.io this projects environment",type:"boolean",default:!0},main:{default:"index",alias:"e",describe:"Application main file, default is index.js"}};function showHistory(a,{admintoken:b,myAPIKey:c}){let d={},e={$max:-1,$orderby:{_id:-1}},f=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${a.space}/_A_D_M_query/${"_hooks"}?q=${JSON.stringify(d)}&h=${JSON.stringify(e)}`:`https://${a.projectname}.api.codehooks.io/${a.space}/_A_D_M_query/${"_hooks"}?q=${JSON.stringify(d)}&h=${JSON.stringify(e)}`;f=f.replace(/ /g,"");const g={"cache-control":"no-cache","content-type":"application/json",host:`${a.projectname}.api.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`};b?g["x-admintoken"]=b:g.Authorization=`Bearer ${c}`;const h={method:"GET",headers:g,json:!0};a.debug&&console.log(f,h,"ENV",process.env.COHO_APIGW_URL),fetch(f,h).then(b=>{if(a.debug&&console.log(b.status,b.statusText),201<b.status)throw Error(b.status+" status code, not logged in?");return b.json()}).then(b=>{//console.log(json);
let c=[];b.forEach(a=>{let b={User:lodash.get(a,"headers.x-userfullname","-"),Date:lodash.get(a,"headers.x-date","-"),GitHash:lodash.get(a,"headers.x-githash","-"),GitBranch:lodash.get(a,"headers.x-gitbranch","-"),DeploymentID:a._id};0===c.length&&(b.Date+=" (active)"),c.push(b)}),a.json?console.log(c):tables.showTableFormat(c),0===b.length&&console.log("No code deployed to this space yet.")}).catch(b=>{a.debug?console.error(b):console.error("Some error occured:",b.message)})}function rollBack(a,{admintoken:b,myAPIKey:c}){console.log("Rollback cmd");let d=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${a.space}/_A_D_M_deploy`:`https://${a.projectname}.api.codehooks.io/${a.space}/_A_D_M_deploy`;const e={"cache-control":"no-cache","content-type":"application/json",host:`${a.projectname}.api.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`};b?e["x-admintoken"]=b:e.Authorization=`Bearer ${c}`;fetch(d,{method:"DELETE",headers:e,json:!0}).then(a=>{if(201<a.status)throw Error(a.status+" status code, not logged in?");return a.json()}).then(a=>{console.log(a)}).catch(a=>console.error(a))}function getGitHash(){try{return require("child_process").execSync("git rev-parse HEAD").toString().replace(/\r?\n|\r/g,"")}catch(a){return"-no git hash-"}}function getGitBranch(){try{return require("child_process").execSync("git branch").toString().replace(/\r?\n|\r/g,"").replace("* ","")}catch(a){return"-no git branch-"}}exports.handler=function(a){const{admintoken:b,_auth:c={}}=a,d=!b?config.get("token"):null,e={admintoken:b,myAPIKey:d};if(a.history)return showHistory(a,e);return a.rollback?rollBack(a,e):void checkLanguage(async(f,g)=>{f&&(console.error(f),process.exit(0));let h=null;try{msg("Deploying code ..."),h=await compile(a.dir,g)}catch(a){console.error(a),process.exit()}let i=null,j=null;fs.existsSync(`${process.cwd()}/.git`)&&(i=getGitHash(),j=getGitBranch());const k=c.name||"",l=c.email||"",m={"x-file-name":"bundle.js","Content-Type":"application/json","Content-length":h.length,"x-githash":i,"x-gitbranch":j,"x-userfullname":k,"x-useremail":l,"x-date":new Date().toISOString(),"x-language":g,host:`${a.projectname}.api.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`};e.admintoken?m["x-admintoken"]=b:m.Authorization=`Bearer ${d}`;const n={method:"POST",headers:m,body:JSON.stringify({bundle:h}),json:!0,redirect:"follow"};a.template&&(n.body=JSON.stringify({templateBundleId:a.template}));const o=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${a.space}/_A_D_M_deploy`:`https://${a.projectname}.api.codehooks.io/${a.space}/_A_D_M_deploy`;a.debug&&console.log(o,n),fetch(o,n).then(async function(b){if(a.debug&&console.error(b.status+" "+b.statusText),400<=b.status){spinner&&spinner.stop(),console.error(`Unable to perform deploy. ${b.status} ${b.statusText}`);const a=await b.json();console.log(chalk.red(a.error||a)),process.exit(1)}return b.json()}).then(function(b){b.error?(spinner&&spinner.stop(),console.log(chalk.red(b.error))):uploadSourceCode(a,()=>{spinner&&spinner.stop(),console.log("\nProject: "+a.projectname," Space: "+a.space),console.log(chalk.green("Deployed Codehook successfully! \uD83D\uDE4C \n")),console.log(chalk.blue("Check your logs with: coho logs --follow\n"))})}).catch(b=>{spinner&&spinner.stop(),a.debug?console.error(b):console.log(chalk.red("Fail"),b)})})};function uploadSourceCode(a,b){if(!a.upload)return b(null,"done");const{admintoken:c,_auth:d={}}=a,e=!c?config.get("token"):null,f={admintoken:c,myAPIKey:e};let g=dirTree("./",{attributes:["size","type","extension"],extensions:/\.(md|js|jsx|ts|tsx|html|css|json|yml|yaml|xml)$/,exclude:[/node_modules/,/^\.git/,/^\.DS_/,/^.localserver/]}),h=[];traverse(g).forEach(a=>{a&&a.path&&a.type&&"file"===a.type&&h.push(a.path)}),a.debug&&console.log(h);var i=async.queue(async function(b,d){var g={"Content-Type":"application/octet-stream",host:`${a.projectname}.meta.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`,"x-space":a.space};f.admintoken?g["x-admintoken"]=c:g.Authorization=`Bearer ${e}`;const h=path.join(process.cwd(),b.filePath),i=fs.readFileSync(h,{flag:"r"}),j={method:"POST",headers:g,body:i,redirect:"follow",rejectUnauthorized:!1},k=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${a.space}/src/${encodeURIComponent(b.filePath)}`:`https://${a.projectname}.meta.codehooks.io/${a.space}/src/${encodeURIComponent(b.filePath)}`;//console.log('Upload', thePath)
a.debug&&console.log(k,j),fetch(k,j).then(a=>a.text()).then(b=>a.debug?console.log(b):0).catch(a=>console.log("error",a)),d()},3);// assign a callback
i.drain(function(){b(null,"all files have been saved")}),h.forEach(a=>{i.push({filePath:a})})}