"use strict";const fetch=require("node-fetch"),Table=require("cli-table3"),config=require("../config").global,projectConfig=require("../config").project,_=require("lodash"),{format}=require("@fast-csv/format"),q2m=require("query-to-mongo"),{Transform,pipeline}=require("node:stream"),{promisify}=require("node:util"),streamPipeline=promisify(pipeline),streamHandler=require("../lib/streamHandler"),JSONStream=require("JSONStream"),{createWriteStream}=require("node:fs"),util=require("util"),chalk=require("chalk");// regex serializer
RegExp.prototype.toJSON=function(){return{$regex:this.toString().replace(/\//gi,""),$options:"i"}},exports.command="query [collection] [query]",exports.aliases=["q"],exports.desc="Run query on collection in current space",exports.example=["$0 count -f","foo.js"],exports.builder=a=>{a.option("project",{default:projectConfig.get("name"),alias:"p",describe:"Select which project to query"}).option("space",{alias:"s",default:projectConfig.get("space"),describe:"Select which space to query"}).options("query",{default:"",alias:"q",describe:"Limit selection with a query expression",example:"coho query xx=yy"}).options("count",{alias:"n",describe:"Count query results"}).options("collection",{required:!0/* enable colors */,alias:"c",describe:"Collection name"}).options("delete",{describe:"Delete all items from query result",conflics:"update, replace"}).options("update",{describe:"Patch all items from query result with JSON string '{...}'",type:"string",conflics:"replace, delete"}).options("replace",{describe:"Replace all items from query result with JSON string '{...}'",type:"string",conflics:["update","delete"]}).options("useindex",{describe:"Use an indexed field to scan data in query",type:"string"}).options("start",{describe:"Start value for index scan",type:"string"}).options("end",{describe:"End value for index scan",type:"string"}).options("limit",{describe:"Limit query result",type:"number"}).options("fields",{describe:"Comma separated list of fields to include",type:"string"}).options("sort",{describe:"Comma separated list of fields to sort by",type:"string"}).options("offset",{describe:"Skip items before returning data in query result",type:"number"}).options("enqueue",{describe:"Add query result to queue topic",type:"string"}).options("pretty",{describe:"Output data with formatting and colors"}).options("reverse",{describe:"Scan index in reverse order"}).options("table",{type:"boolean",desc:"Output data as formatted table (not JSON)"}).options("csv",{type:"boolean",desc:"Output data in CSV format"}).options("admintoken",{describe:"Use admin token authentication (use for CI)"}).example("$0 query pets name=Polly").example("$0 query --collection pets --query 'name=Polly&type=Parrot'").example("$0 query --collection pets --query 'name=/^po/'").example("$0 query --collection pets --query 'name=/^po/' --sort 'age,name'").example("$0 query pets 'name=Polly' --useindex name --fields 'name,type'").example("$0 q pets 'name=Polly&type=Parrot' --update '{\"name\": \"Zilla\"}'").example("$0 q pets 'type=Fish' --delete").example("$0 q pets 'type=Snake' --enqueue 'mytopic'")},exports.handler=async function(a){const b=a.admintoken?null:config.get("token");let c=a.collection,d=q2m(a.query).criteria,e={};a.count&&(e.count=!0),a.sort&&(e=q2m("sort="+a.sort).options);// todo: add sort
const f=process.env.COHO_APIGW_URL?`${process.env.COHO_APIGW_URL}/${a.space}/_A_D_M_query/${c}?q=${JSON.stringify(d)}&h=${JSON.stringify(e)}`:`https://${a.project}.api.codehooks.io/${a.space}/_A_D_M_query/${c}?q=${JSON.stringify(d)}&h=${JSON.stringify(e)}`,g={"cache-control":"no-cache","content-type":"application/json",host:`${a.project}.api.codehooks.${process.env.COHO_APIGW_URL?"local.":""}io`};a.admintoken?g["x-admintoken"]=a.admintoken:g.Authorization=`Bearer ${b}`;const h={method:"GET",headers:g,json:!0},i={};if(a.delete&&((a.update||a.replace)&&(console.error("Cannot mix delete, update or replace"),process.exit(1)),h.headers["x-deletebyquery"]=JSON.stringify(JSON.parse(a.delete))),a.update&&((a.delete||a.replace)&&(console.error("Cannot mix delete, update or replace"),process.exit(1)),h.headers["x-updatebyquery"]=JSON.stringify(JSON.parse(a.update))),a.replace&&((a.update||a.delete)&&(console.error("Cannot mix delete, update or replace"),process.exit(1)),h.headers["x-replacebyquery"]=JSON.stringify(JSON.parse(a.replace))),a.useindex&&(i.useIndex=a.useindex),a.start){let b=+a.start;i.start=isNaN(a.start)?a.start:b}if(a.end){let b=+a.end;i.end=isNaN(a.end)?a.end:b}a.limit&&(i.limit=a.limit),a.offset&&(i.offset=a.offset),a.reverse&&(i.reverse=a.reverse),a.enqueue&&(i.enqueue=a.enqueue),a.fields&&(i.hints=q2m("fields="+a.fields).options),i.noTimeout=!0,h.headers["x-options"]=JSON.stringify(i),a.debug&&(console.log("Query called",a),console.log(d,e),console.log(f,h)),1<[a.table,a.pretty,a.csv].filter(a=>!0===a).length&&(console.error("Please choose either --pretty, --table or --csv (or none)"),process.exit(1));try{const b=await fetch(f,h);if(400<=b.status){console.error(`Unable to execute command. ${b.status} ${b.statusText}`);const a=await b.text();console.error(chalk.red(a)),process.exit(1)}else if(a.table){const a=await b.json();showTableFormat(a),process.exit()}else if(a.pretty)await streamHandler(b.body.pipe(JSONStream.parse("*")),{onData:a=>console.log(util.inspect(a,{showHidden:!1,depth:null,colors:!0}))}),process.exit();else if(a.csv){const a=[];await streamHandler(b.body.pipe(JSONStream.parse("*")),{onData:b=>{a.push(b)},onEnd:()=>{const b=new Set;a.forEach(a=>{Object.keys(a).forEach(a=>b.add(a))});// Convert the set of keys to an array, optional sorting can be done here
const c=Array.from(b),d=format({headers:c,writeHeaders:!0});d.pipe(process.stdout),a.forEach(a=>{d.write(a)}),d.end()}})}else await streamPipeline(b.body,process.stdout),process.exit()}catch(b){console.error("An error occured. Unable to process query."),a.debug&&console.log(b),process.exit(1)}};const showTableFormat=a=>{// print schema
var b={};_.each(a,a=>{_.each(a,(a,c)=>{//console.log(key);
b[c]=typeof a})});var c=new Table({head:["","Field","Type"]}),d=0;//xtable.concat(schema);
_.each(b,(a,b)=>{("_"!==b[0]||"_id"===b)&&c.push([d++,b,a])});var e,f=Array(d),g=process.stdout.columns/d;for(e=0;e<d;e++)f[e]=Math.floor(g)-2;//console.log("Schema")
//console.log(xtable.toString());
// instantiate auto col widths
var h=new Table({head:_.map(c,a=>a[1]),colWidths:f});_.each(a,a=>{var c=[];_.each(b,(b,d)=>{if("_"!==d[0]||"_id"===d){var e=a[d];//console.log("val", prop, key, val, typeof val)
c.push(e&&e.toString?"object"==typeof e?JSON.stringify(e):e.toString():e)}}),h.push(c)}),console.log(h.toString())};